#!/usr/bin/env python

import os
import zulip
import re


def handle_event(msg):
    if msg.get('type') == 'message':
        if regex.search(msg.get('message').get('content')) is not None:
            message_data = {
                "content": "[OH YEAH!]({})".format(oh_yeah['uri'])
            }
            if msg.get('message').get('stream_id') is not None:
                message_data['type'] = 'stream'
                message_data['to'] = msg.get('message').get('stream_id')
                message_data['topic'] = msg.get('message').get('subject')
            else:
                message_data['type'] = 'private'
                message_data['to'] = [msg.get('message').get('sender_email')]
            client.send_message(message_data)


client = zulip.Client(email=os.environ['ZULIP_EMAIL'], api_key=os.environ['ZULIP_API_KEY'], site=os.environ['ZULIP_SITE'])
with open('ohyeah.png', 'rb') as f:
    oh_yeah = client.upload_file(f)
regex = re.compile(r'(^|\W)oh\W? ?no(\W|$)', re.IGNORECASE)
client.call_on_each_event(lambda event: handle_event(event), all_public_streams=True)
